import React, { useRef, useState, useEffect } from "react";
import TextField from '@mui/material/TextField';
import MenuItem from '@mui/material/MenuItem';
import 'react-confirm-alert/src/react-confirm-alert.css'; // Import css
import Button from '@mui/material/Button';
import axios from "axios";
import { getCookie, setCookie } from 'react-use-cookie';
import { useHistory } from "react-router-dom";
import CheckOut from "./CheckOut";
import { DataGrid, GridToolbar, frFR } from '@mui/x-data-grid';
import "react-draft-wysiwyg/dist/react-draft-wysiwyg.css";
import { Editor } from '@tinymce/tinymce-react';
import parse from 'html-react-parser';
import { FcViewDetails, FcDisapprove } from "react-icons/fc";
import 'react-tooltip/dist/react-tooltip.css'
import { Tooltip } from 'react-tooltip'
import add_plus from "../mysy_img/plus.png";
import excel_icone from "../mysy_img/excel_icone.png";
import participants from "../mysy_img/participants.png";
import fileDownload from 'js-file-download'
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import { FcCancel, FcApproval, FcAcceptDatabase, FcPrint } from "react-icons/fc";
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";
import { format } from 'date-fns'
import moment from "moment";
import InputAdornment from '@mui/material/InputAdornment';
import { AiFillCloseCircle } from "react-icons/ai";
import Box from '@mui/material/Box';
import { Typography, LinearProgress, sliderClasses } from '@mui/material';
import styled from 'styled-components';
import { CiTrash } from "react-icons/ci";
import { MdAddCircleOutline, MdRemoveCircleOutline } from "react-icons/md";
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import { TransitionProps } from '@mui/material/transitions';


const Partner_Commande = (props) => {

    const history = useHistory();
    const [submenu, setsubmenu] = useState("");
    const [rowss, setRows] = useState([]);
    const [selectionModel, setSelectionModel] = React.useState([]);

    const [rows_order_lines, setrows_order_lines] = useState([]);
    const [selectionModel_order_lines, setselectionModel_order_lines] = React.useState([]);

    var date_today_90j = new Date();
    date_today_90j.setDate(date_today_90j.getDate() +90);

    const [p_filtre1, setp_filtre1] = useState();
    const [p_filtre1_value, setp_filtre1_value] = useState();

    const [p_filtre2, setp_filtre2] = useState();
    const [p_filtre2_value, setp_filtre2_value] = useState();

    const [p_filtre3, setp_filtre3] = useState();
    const [p_filtre3_value, setp_filtre3_value] = useState();

    const [p_filtre4, setp_filtre4] = useState();
    const [p_filtre4_value, setp_filtre4_value] = useState();
    const columns = [
        { field: '_id', headerName: '_id', hide: true },
        { field: 'id', headerName: 'id', hide: true },
        { field: 'order_header_ref_interne', headerName: 'Reference', width: 150, hide: false, editable: true },
        { field: 'order_header_type', headerName: 'Type', width: 150, hide: false, editable: true },
        {
            field: 'order_header_status', headerName: 'Statut', width: 150, hide: false, editable: true,
            valueFormatter: (params) => {
                if (String(params.value) === "-1")
                    return "Annulé";
                else if (String(params.value) === "0")
                    return "Brouillon";
                else if (String(params.value) === "1")
                    return "En cours";
                else if (String(params.value) === "2")
                    return "Traité";
                else if (String(params.value) === "3")
                    return "Facturé";
                else
                    return "?";

            },
        },
        { field: 'order_header_client_id', headerName: 'Client_Id', width: 150, hideable: false, },
        { field: 'order_header_client_nom', headerName: 'Nom Client', width: 150, hideable: false, },
        { field: 'order_header_vendeur_id', headerName: 'Vendeur Id', width: 150, hideable: false, },
        { field: 'order_header_vendeur_nom_prenom', headerName: 'Vendeur', width: 150, hideable: false, },
        { field: 'order_header_date_cmd', headerName: 'Date', width: 150, hide: false, editable: true },
        { field: 'order_header_date_expiration', headerName: 'Date Expiration', width: 150, hide: false, editable: true },


        /* {
             field: "Detail", headerName: 'Voir detail',
             renderCell: (cellValues) => {
                 return (
 
                     <Button
 
                         onClick={(event) => {
                             Display_Detail_Employe(event, cellValues);
                         }}
                     >
                         <FcViewDetails />
 
                     </Button>
 
                 );
             }
         },*/
        {
            field: "delete", headerName: 'Supprimer',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button

                            onClick={(event) => {
                                // handleClick_delete(event, cellValues);
                            }}
                        >
                            <CiTrash />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Information </div>
                                <div className="gest_content">
                                    {' '}

                                    En confirmant cette opération, l'employé sera <i><font color="red"> définitivement supprimé</font></i>. <br />

                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            //handleClick_delete(event, cellValues);
                                            //console.log('modal closed ');
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                //console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>


                );
            }
        }

    ]


    const columns_order_lines = [
        { field: '_id', headerName: '_id', hide: true, editable: false },
        { field: 'id', headerName: 'id', hide: true, editable: false },
        { field: 'order_line_formation', headerName: 'intenal_url', width: 0, hide: true, editable: false },
        { field: 'order_line_formation_title', headerName: 'Titre', width: 150, hide: false, editable: false },
        { field: 'order_line_formation_duration', headerName: 'Durée', width: 150, hide: false, editable: false },

        { field: 'order_line_qty', headerName: 'Qte', width: 150, hide: false, editable: false },
        { field: 'order_line_prix_unitaire', headerName: 'Prix Unit.', width: 150, hide: false, editable: false },
        { field: 'order_header_id', headerName: 'Id_Entete', width: 150, hideable: false, editable: false },
        { field: 'order_header_ref_interne', headerName: 'Ref_Interne', width: 150, hideable: false, editable: false },
        { field: 'order_line_type', headerName: 'Type', width: 150, hide: false, editable: false },
        {
            field: 'order_line_status', headerName: 'Statut', width: 150, hide: false, editable: true,
            valueFormatter: (params) => {
                if (String(params.value) === "-1")
                    return "Annulé";
                else if (String(params.value) === "0")
                    return "Brouillon";
                else if (String(params.value) === "1")
                    return "En cours";
                else if (String(params.value) === "2")
                    return "Traité";
                else if (String(params.value) === "3")
                    return "Facturé";
                else
                    return "?";

            },
        },
        {
            field: "Detail", headerName: 'Voir detail',
            renderCell: (cellValues) => {
                return (

                    <Button

                        onClick={(event) => {
                            Display_Detail_Order_Line(event, cellValues);
                        }}
                    >
                        <FcViewDetails />

                    </Button>

                );
            }
        },
        {
            field: "delete", headerName: 'Supprimer',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button

                            onClick={(event) => {
                                // handleClick_delete(event, cellValues);
                            }}
                        >
                            <CiTrash />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Information </div>
                                <div className="gest_content">
                                    {' '}

                                    En confirmant cette opération, la ligne sera <i><font color="red"> définitivement supprimée</font></i>. <br />

                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            handleClick_delete_Order_line(event, cellValues);
                                            //console.log('modal closed ');
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                //console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>


                );
            }
        },
        { field: 'order_line_comment', headerName: 'Commentaire', width: 150, hide: true, editable: false, },

    ]


    function Display_Detail_Order_Line(event, cellValues) {

        var order_line_id = String(cellValues.row._id);

        var order_line_formation = String(cellValues.row.order_line_formation);
        var order_line_qty = String(cellValues.row.order_line_qty);
        var order_line_prix_unitaire = String(cellValues.row.order_line_prix_unitaire);

        setselected_order_line_id(order_line_id);

        setp_add_line_item(order_line_formation);
        setp_add_line_item_qty(order_line_qty);
        setp_add_line_item_price(order_line_prix_unitaire);
        setp_add_line_item_status(String(cellValues.row.order_line_status));
        setp_add_line_item_type(String(cellValues.row.order_line_type));
        setp_add_line_item_comment(String(cellValues.row.order_line_comment));



        setDialog_Detail_Article_open(true);
        //alert(" afficher le detail de la ligne " + String(order_line_id));

    }


    function clean_all_filters() {
        setp_filtre1();
        setp_filtre1_value();

        setp_filtre2();
        setp_filtre2_value();

        setp_filtre3();
        setp_filtre3_value();

        setp_filtre4();
        setp_filtre4_value();
    }


    function handleClick_delete_Order_line(event, cellValues) {

        var local_order_line_id = cellValues.row._id;

        Delete_Order_Line_Data(local_order_line_id);
    }

    const [Delete_Order_Line_Data_api, setDelete_Order_Line_Data_api] = useState();
    const [Delete_Order_Line_Data_message, setDelete_Order_Line_Data_message] = useState();
    const [Delete_Order_Line_Data_result, setDelete_Order_Line_Data_result] = useState();
    function Delete_Order_Line_Data(local_order_line_id) {

        var form = new FormData();

        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("order_line_id", local_order_line_id);
        form.append("order_header_id", selected_id);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Delete_Partner_Order_Line/";

        axios.post(myurl, form).then(res => {
            //console.log(" In Delete_Order_Line_Data  res.data.status = " + res.data.status);
            //console.log(" In Delete_Order_Line_Data  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setDelete_Order_Line_Data_api("true");
                setDelete_Order_Line_Data_result(res.data.message);

                Display_Detail_Order_data(selected_id);

                alert(res.data.message);
            }
            else {
                setDelete_Order_Line_Data_api("false");
                setDelete_Order_Line_Data_message(res.data.message);
                alert(res.data.message);

            }

        }).catch((error) => {

            console.log('Delete_Order_Line_Data : Not good man :( Delete_Order_Line_Data = ' + error);
            setDelete_Order_Line_Data_api("false");
            alert(" Impossible de supprimer la ligne");
        })
    }


    const myRef = useRef(null)

    const [Dialog_1_message, setDialog_1_message] = React.useState(false);
    const [Dialog_1_open, setDialog_1_open] = React.useState(false);
    function Dialog_1_handle_change_participant_session(message) {
        setDialog_1_message(message);
        setDialog_1_open(true);
    }

    const Dialog_1_handleClose = () => {
        //alert(" Utiliser le bouton 'fermer' ");
        //setOpen(false);
    };

    const Dialog_1_handleClose_buton = () => {
        setDialog_1_open(false);
    };

    const [GetCurrentPartnerClass_api, setGetCurrentPartnerClass_api] = useState();
    const [GetCurrentPartnerClass_message, setGetCurrentPartnerClass_message] = useState();
    const [GetCurrentPartnerClass_result, setGetCurrentPartnerClass_result] = useState();
    function GetCurrentPartnerClass(event) {
        var form = new FormData();



        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/get_partner_class/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In GetCurrentPartnerClass  res.data.status = " + res.data.status);
                //console.log(" In GetCurrentPartnerClass  res.data.message r_class = " + res.data.message);
                setGetCurrentPartnerClass_api("true");
                setGetCurrentPartnerClass_result(res.data.message);


            } else if (String(res.data.status) === String("Err_Connexion")) {
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
            }
            else {
                setGetCurrentPartnerClass_api("false");
                setGetCurrentPartnerClass_message(res.data.message);
                alert('Erreur: ' + res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( mysearchtext = ', error);
            setGetCurrentPartnerClass_api("false");
            alert(" Impossible de recuperer la liste des formations")
        })
    }


    useEffect(() => {

        Get_List_Partner_Clients();
        Getall_Training_Employee_No_Filter();
        Getall_Parter_Orders_No_Filter();
        GetCurrentPartnerClass();
    }, [])

    const [Getall_Parter_Orders_No_Filter_api, setGetall_Parter_Orders_No_Filter_api] = useState();
    const [Getall_Parter_Orders_No_Filter_message, setGetall_Parter_Orders_No_Filter_message] = useState();
    const [Getall_Parter_Orders_No_Filter_result, setGetall_Parter_Orders_No_Filter_result] = useState();
    function Getall_Parter_Orders_No_Filter(event) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Partner_Order_no_filter/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Parter_Orders_No_Filter  res.data.status = " + res.data.status);
                //console.log(" In Getall_Parter_Orders_No_Filter  res.data.message r_class = " + res.data.message);
                setGetall_Parter_Orders_No_Filter_api("true");
                setGetall_Parter_Orders_No_Filter_result(res.data.message);
                setRows(res.data.message);
            }
            else {
                setGetall_Parter_Orders_No_Filter_api("false");
                setGetall_Parter_Orders_No_Filter_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Getall_Parter_Orders_No_Filter = ', error);
            setGetall_Parter_Orders_No_Filter_api("false");
            alert(" Impossible de recuperer la liste des commandes et devis");
            //setmyApimyApiMessage("")
        })
    }


    const [session_file_name, setsession_file_name] = useState();
    const [liste_sessions_file_change_api, setliste_sessions_file_change_api] = useState();
    const [liste_sessions_file_change_result, setliste_sessions_file_change_result] = useState();
    const [liste_sessions_file_change_message, setliste_sessions_file_change_message] = useState();
    const liste_sessions_file_change = event => {


        const fileUploaded = event.target.files[0];
        let file_size = event.target.files[0].size;
        let file_type = event.target.files[0].type;

        //console.log("file_size =  ",file_size," file_type = ",file_type);
        if (file_size > 1000000) {
            alert("Le fichier ne doit pas depasser un 1 Méga octets");
            return;
        }

        setsession_file_name(event.target.files[0].name);

        const formData = new FormData();
        formData.append('File', fileUploaded);
        //formData.append('token', 'K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA');
        const stored_cookie = getCookie('tokenmysypart');

        formData.append("token", stored_cookie);
        //console.log("token = " + stored_cookie);

        fetch(
            // ici a modifier process.env.REACT_APP_API_URL + "myclass/api/Add_Ressource_Humaine_mass/",
            {
                method: 'POST',
                body: formData,
            }
        )
            .then((response) => response.json())
            .then((result) => {

                //console.log(" ## result['status'] = ", result['status'])
                if (String(result['status']) === String("Err_Connexion")) {
                    alert('Erreur: ' + result['message']);
                    history.push("/Connexion");
                }

                else if (String(result['status']) === String("true")) {
                    //console.log('Success:', result['message']);
                    setliste_sessions_file_change_result(result['message']);
                    setliste_sessions_file_change_api("true");

                    //Getall_Training_Employee();
                    alert(" Les employés ont été correctement importés");

                }

                else {
                    setliste_sessions_file_change_message(result['message']);
                    setliste_sessions_file_change_api("false");
                    alert('Erreur: ' + result['message']);

                }


            })
            .catch((error) => {
                console.error('Error:', error);
                setliste_sessions_file_change_api("false");
                alert(" Impossible d'importer les employés ");
            });
    }

    const myRef_head = useRef(null);
    const [selected_id, setselected_id] = useState("");
    const [selected_order_line_id, setselected_order_line_id] = useState("");

    const [order_internal_ref, setorder_internal_ref] = useState("");
    function handleClick_edit_order_From_Line(selected_row_id) {

        //submenu_detail_employe();

        var line = JSON.parse(rowss[selected_row_id]);

        //console.log("### line = ", line);
        var order_id = line._id;
        setselected_id(order_id);

        var order_ref = line.order_header_ref_interne;
        setorder_internal_ref(order_ref);

        //console.log(" ### employe_id  = ", employe_id);
        Display_Detail_Order_data(order_id);

        if (myRef.current) {
            myRef.current.scrollIntoView({ behavior: "smooth" });
        }

        //Getall_Employee_Affectation(employe_id);

    }

    function Display_Detail_Order_data(order_id) {
        //clearDetailAttendeFields();
        setadd_One_Order();
        setdisplay_detail_order("1");
        setsubmenu("detail_order");

        Get_Order_Data(order_id);
        Get_Partner_Orders_Lines_from_header_id(order_id);

    }

    const [Order_data_changed, setOrder_data_changed] = useState();
    const [order_data_edit_mode, setorder_data_edit_mode] = useState();


    const [GetAttendee_api, setGetAttendee_api] = useState();
    const [GetAttendee_message, setGetAttendee_message] = useState();
    const [GetAttendee_result, setGetAttendee_result] = useState();
    function Get_Order_Data(order_id) {
        setOrder_data_changed("");
        setorder_data_edit_mode("");


        var form = new FormData();

        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("_id", order_id);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Given_Partner_Order/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === "true") {
                //console.log(" In Get_Order_Data  res.data.status = " + res.data.status);
                //console.log(" In Get_Order_Data  res.data.message r_class = " + res.data.message);
                setGetAttendee_api("true");
                setGetAttendee_result(res.data.message);

                if (res.data.message.length > 0) {
                    var mylocal_order = JSON.parse(res.data.message);


                    document.getElementsByName("detail_header_type")[0].value = "";
                    if (mylocal_order.order_header_type)
                        setp_detail_header_type(mylocal_order.order_header_type);

                    document.getElementsByName("detail_header_status")[0].value = "";
                    if (mylocal_order.order_header_status) {
                        setp_detail_header_statut(mylocal_order.order_header_status);
                        if (String(mylocal_order.order_header_status) === "0") {
                            setp_detail_header_statut_label("Brouillon");
                        }
                        else if (String(mylocal_order.order_header_status) === "1") {
                            setp_detail_header_statut_label("En cours");
                        }
                        else if (String(mylocal_order.order_header_status) === "2") {
                            setp_detail_header_statut_label("Traité");
                        }
                        else if (String(mylocal_order.order_header_status) === "3") {
                            setp_detail_header_statut_label("Facturé");
                        }
                        else if (String(mylocal_order.order_header_status) === "-1") {
                            setp_detail_header_statut_label("Annulé");
                        }

                    }
                    else {
                        setp_detail_header_statut("0");
                        setp_detail_header_statut_label("Brouillon");
                    }

                    document.getElementsByName("detail_header_ref_interne")[0].value = "";
                    if (mylocal_order.order_header_ref_interne) {
                        setp_detail_header_ref_interne(mylocal_order.order_header_ref_interne);
                    }

                    document.getElementsByName("detail_header_date_cmd")[0].value = "";
                    if (mylocal_order.order_header_date_cmd) {
                        setp_detail_header_date_cmd(mylocal_order.order_header_date_cmd);
                        setp_detail_header_date_cmd_val(mylocal_order.order_header_date_cmd);
                    }

                    document.getElementsByName("detail_header_date_expiration")[0].value = "";
                    if (mylocal_order.order_header_date_expiration) {
                        setp_detail_header_date_expiration(mylocal_order.order_header_date_expiration);
                        setp_detail_header_date_expiration_val(mylocal_order.order_header_date_cmd);
                    }


                    document.getElementsByName("detail_nom_client")[0].value = "";
                    if (mylocal_order.order_header_client_nom) {
                        setp_detail_header_client_nom(mylocal_order.order_header_client_nom);
                        setp_detail_header_client_nom_id(mylocal_order.order_header_client_id);
                    }


                    document.getElementsByName("detail_header_description")[0].value = "";
                    if (mylocal_order.order_header_description) {
                        setp_detail_header_description(mylocal_order.order_header_description);
                    }

                    document.getElementsByName("detail_header_comment")[0].value = "";
                    if (mylocal_order.order_header_comment) {
                        setp_detail_header_comment(mylocal_order.order_header_comment);
                    }


                    document.getElementsByName("detail_header_vendeur_nom_prenom")[0].value = "";
                    if (mylocal_order.order_header_vendeur_nom_prenom) {
                        setp_detail_header_vendeur_nom(mylocal_order.order_header_vendeur_nom_prenom);
                        setp_detail_header_vendeur_nom_id(mylocal_order.order_header_vendeur_id);
                    }


                    disable_Order_Header_DetailFields();

                } else {
                    alert(" Aucune commande/devis recuperé");
                }


            } else if (String(res.data.status) === String("Err_Connexion")) {
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
            }

            else {
                setGetAttendee_api("false");
                setGetAttendee_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_Order_Data = ', error);
            setGetAttendee_api("false");
            alert(" Impossible de recuperer les données de la commande / devis");
            //setmyApimyApiMessage("")
        })
    }


    const [Get_Partner_Orders_Lines_from_header_id_api, setGet_Partner_Orders_Lines_from_header_id_api] = useState();
    const [Get_Partner_Orders_Lines_from_header_id_message, setGet_Partner_Orders_Lines_from_header_id_message] = useState();
    const [Get_Partner_Orders_Lines_from_header_id_result, setGet_Partner_Orders_Lines_from_header_id_result] = useState();
    function Get_Partner_Orders_Lines_from_header_id(local_order_header_id) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("order_header_id", local_order_header_id);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Given_Partner_Order_Lines/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Get_Partner_Orders_Lines_from_header_id  res.data.status = " + res.data.status);
                //console.log(" In Get_Partner_Orders_Lines_from_header_id  res.data.message r_class = " + res.data.message);
                setGet_Partner_Orders_Lines_from_header_id_api("true");
                setGet_Partner_Orders_Lines_from_header_id_result(res.data.message);
                setrows_order_lines(res.data.message);
            }
            else {
                setGet_Partner_Orders_Lines_from_header_id_api("false");
                setGet_Partner_Orders_Lines_from_header_id_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_Partner_Orders_Lines_from_header_id = ', error);
            setGet_Partner_Orders_Lines_from_header_id_api("false");
            alert(" Impossible de recuperer le detail de la commande / devis");
            //setmyApimyApiMessage("")
        })
    }

    const [Get_List_Partner_Clients_api, setGet_List_Partner_Clients_api] = useState();
    const [Get_List_Partner_Clients_message, setGet_List_Partner_Clients_message] = useState();
    const [Get_List_Partner_Clients_result, setGet_List_Partner_Clients_result] = useState();
    function Get_List_Partner_Clients(event) {

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');

        form.append("token", stored_cookie);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Partner_List_Partner_Client/";

        axios.post(myurl, form).then(res => {
            //console.log(" In Get_List_Partner_Clients  res.data.status = " + res.data.status);
            //console.log(" In Get_List_Partner_Clients  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setGet_List_Partner_Clients_api("true");
                setGet_List_Partner_Clients_result(res.data.message);
            }
            else if (String(res.data.status) === String("Err_Connexion")) {
                alert('Erreur: ' + res.data.message);
                history.push("/Connexion");
            }
            else {
                setGet_List_Partner_Clients_api("false");
                setGet_List_Partner_Clients_message(res.data.message);
                alert('Erreur: ' + res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_List_Partner_Clients = ', error);
            setGet_List_Partner_Clients_api("false");
            alert('Erreur: Impossible de recuperer la liste des clients');
            //setmyApimyApiMessage("")
        })
    }


    const hiddenFileInput_session = React.useRef(null);

    function submenu_import_order() {
        setsession_file_name();
        setliste_sessions_file_change_api();
        hiddenFileInput_session.current.click();
    }

    const [add_One_Order, setadd_One_Order] = useState();
    function submenu_add_one_order() {
        setDialog_Detail_Commande_open(true);


    }

    function Annule_add_one_Order() {
        setdisplay_detail_order();
        setsubmenu("");
        setSelectionModel([]);
    }

    const [display_detail_order, setdisplay_detail_order] = React.useState();

    const [p_detail_header_client_nom, setp_detail_header_client_nom] = useState();
    const [p_detail_header_client_nom_id, setp_detail_header_client_nom_id] = useState();

    const [p_detail_header_description, setp_detail_header_description] = useState();
    const [p_detail_header_comment, setp_detail_header_comment] = useState();
    const [p_detail_header_date_cmd, setp_detail_header_date_cmd] = useState();
    const [p_detail_header_date_expiration, setp_detail_header_date_expiration] = useState();
    const [p_detail_header_condition_paiement, setp_detail_header_condition_paiement] = useState();
    const [p_detail_header_ref_client, setp_detail_header_ref_client] = useState();
    const [p_detail_header_ref_interne, setp_detail_header_ref_interne] = useState();

    const [p_detail_header_vendeur_nom, setp_detail_header_vendeur_nom] = useState();
    const [p_detail_header_vendeur_nom_id, setp_detail_header_vendeur_nom_id] = useState();

    const [p_detail_header_type, setp_detail_header_type] = useState();
    const [p_detail_header_statut, setp_detail_header_statut] = useState();
    const [p_detail_header_vendeur_id, setp_detail_header_vendeur_id] = useState();
    const [p_detail_header_client_id, setp_detail_header_client_id] = useState();
    const [p_detail_header_statut_label, setp_detail_header_statut_label] = useState();

    const [p_detail_header_date_cmd_val, setp_detail_header_date_cmd_val] = useState(new Date().toLocaleDateString('fr-FR'));
    const [p_detail_header_date_expiration_val, setp_detail_header_date_expiration_val] =  useState(date_today_90j.toLocaleDateString('fr-FR'));


    function Enable_Order_Header_DetailFields() {
        setorder_data_edit_mode("1");

        if (document.getElementsByName("detail_header_type")[0]) {
            document.getElementsByName("detail_header_type")[0].disabled = false;
            document.getElementsByName("detail_header_type")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_status")[0]) {
            document.getElementsByName("detail_header_status")[0].disabled = false;
            document.getElementsByName("detail_header_status")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_ref_interne")[0]) {
            document.getElementsByName("detail_header_ref_interne")[0].disabled = false;
            document.getElementsByName("detail_header_ref_interne")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_date_cmd")[0]) {
            document.getElementsByName("detail_header_date_cmd")[0].disabled = false;
            document.getElementsByName("detail_header_date_cmd")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_date_expiration")[0]) {
            document.getElementsByName("detail_header_date_expiration")[0].disabled = false;
            document.getElementsByName("detail_header_date_expiration")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_nom_client")[0]) {
            document.getElementsByName("detail_nom_client")[0].disabled = false;
            document.getElementsByName("detail_nom_client")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_description")[0]) {
            document.getElementsByName("detail_header_description")[0].disabled = false;
            document.getElementsByName("detail_header_description")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_comment")[0]) {
            document.getElementsByName("detail_header_comment")[0].disabled = false;
            document.getElementsByName("detail_header_comment")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("detail_header_vendeur_nom_prenom")[0]) {
            document.getElementsByName("detail_header_vendeur_nom_prenom")[0].disabled = false;
            document.getElementsByName("detail_header_vendeur_nom_prenom")[0].style.backgroundColor = "#FFFFFF";
        }

    }

    function disable_Order_Header_DetailFields() {
        setorder_data_edit_mode("0");

        if (document.getElementsByName("detail_header_type")[0]) {
            document.getElementsByName("detail_header_type")[0].disabled = true;
            document.getElementsByName("detail_header_type")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_status")[0]) {
            document.getElementsByName("detail_header_status")[0].disabled = true;
            document.getElementsByName("detail_header_status")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_ref_interne")[0]) {
            document.getElementsByName("detail_header_ref_interne")[0].disabled = true;
            document.getElementsByName("detail_header_ref_interne")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_date_cmd")[0]) {
            document.getElementsByName("detail_header_date_cmd")[0].disabled = true;
            document.getElementsByName("detail_header_date_cmd")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_date_expiration")[0]) {
            document.getElementsByName("detail_header_date_expiration")[0].disabled = true;
            document.getElementsByName("detail_header_date_expiration")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_nom_client")[0]) {
            document.getElementsByName("detail_nom_client")[0].disabled = true;
            document.getElementsByName("detail_nom_client")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_description")[0]) {
            document.getElementsByName("detail_header_description")[0].disabled = true;
            document.getElementsByName("detail_header_description")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_comment")[0]) {
            document.getElementsByName("detail_header_comment")[0].disabled = true;
            document.getElementsByName("detail_header_comment")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("detail_header_vendeur_nom_prenom")[0]) {
            document.getElementsByName("detail_header_vendeur_nom_prenom")[0].disabled = true;
            document.getElementsByName("detail_header_vendeur_nom_prenom")[0].style.backgroundColor = "#ECEFF1";
        }

    }

    function Annule_Order_DetailFields() {

        Get_Order_Data(selected_id);
        Get_Partner_Orders_Lines_from_header_id(selected_id);

        setOrder_data_changed("");
        setorder_data_edit_mode("");

    }

    const [Update_One_Order_Data_api, setUpdate_One_Order_Data_api] = useState();
    const [Update_One_Order_Data_message, setUpdate_One_Order_Data_message] = useState();
    const [Update_One_Order_Data_result, setUpdate_One_Order_Data_result] = useState();
    function Update_One_Order_Data() {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("order_header_id", selected_id);
        form.append("order_header_ref_interne", p_detail_header_ref_interne);
        form.append("order_header_type", p_detail_header_type);

        if (p_detail_header_statut)
            form.append("order_header_status", p_detail_header_statut);
        else
            form.append("order_header_status", "0");


        if (p_detail_header_client_nom_id)
            form.append("order_header_client_id", p_detail_header_client_nom_id);
        else
            form.append("order_header_client_id", "");


        if (p_detail_header_vendeur_nom_id)
            form.append("order_header_vendeur_id", p_detail_header_vendeur_nom_id);
        else
            form.append("order_header_vendeur_id", "");

        if (p_detail_header_condition_paiement)
            form.append("order_header_condition_paiement", p_detail_header_condition_paiement);
        else
            form.append("order_header_condition_paiement", "");

        if (p_detail_header_date_expiration)
            form.append("order_header_date_expiration", p_detail_header_date_expiration);
        else
            form.append("order_header_date_expiration", "");

        if (p_detail_header_date_cmd)
            form.append("order_header_date_cmd", p_detail_header_date_cmd);
        else
            form.append("order_header_date_cmd", "");

        if (p_detail_header_comment)
            form.append("order_header_comment", p_detail_header_comment);
        else
            form.append("order_header_comment", "");

        if (p_detail_header_description)
            form.append("order_header_description", p_detail_header_description);
        else
            form.append("order_header_description", "");

        if (p_detail_header_ref_client)
            form.append("order_header_ref_client", p_detail_header_ref_client);
        else
            form.append("order_header_ref_client", "");



        //console.log(" form == ", form);

        var myurl = "";
        if (String(p_detail_header_type) === "commande")
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Update_Partner_Order_Header/";
        else if (String(p_detail_header_type) === "devis")
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Update_Partner_Quotation_Header/";
        else {
            alert(" Type de commande inconnu.");
            return;
        }

        axios.post(myurl, form).then(res => {
            //console.log(" In Update_One_Order_Data  res.data.status = " + res.data.status);
            //console.log(" In Update_One_Order_Data  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setUpdate_One_Order_Data_api("true");
                setUpdate_One_Order_Data_result(res.data.message);

                Getall_Parter_Orders_No_Filter();

                disable_Order_Header_DetailFields();
                setOrder_data_changed("");
                setorder_data_edit_mode("");
                Display_Detail_Order_data(selected_id);
                alert(" La mise à jour été correctement faite.");

                myRef_head.current.scrollIntoView({ behavior: "smooth" });

            }
            else {
                setUpdate_One_Order_Data_api("false");
                setUpdate_One_Order_Data_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {

            console.warn('UpdateStagiaireData : Not good man :( Update_One_Order_Data = ' + error);
            setUpdate_One_Order_Data_api("false");
            alert(" Impossible de mettre à jour la commande/devis");

        })
    }


    const [Getall_Training_Employee_No_Filter_api, setGetall_Training_Employee_No_Filter_api] = useState();
    const [Getall_Training_Employee_No_Filter_message, setGetall_Training_Employee_No_Filter_message] = useState();
    const [Getall_Training_Employee_No_Filter_result, setGetall_Training_Employee_No_Filter_result] = useState();
    function Getall_Training_Employee_No_Filter(event) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Ressource_Humaine_no_filter/";



        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Training_Employee_No_Filter  res.data.status = " + res.data.status);
                //console.log(" In Getall_Training_Employee_No_Filter  res.data.message r_class = " + res.data.message);
                setGetall_Training_Employee_No_Filter_api("true");
                setGetall_Training_Employee_No_Filter_result(res.data.message);
            }
            else {
                setGetall_Training_Employee_No_Filter_api("false");
                setGetall_Training_Employee_No_Filter_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Getall_Training_Employee_No_Filter = ', error);
            setGetall_Training_Employee_No_Filter_api("false");
            alert(" Impossible de recuperer la liste des employés");
            //setmyApimyApiMessage("")
        })
    }


    const [test_comment_dialog, settest_comment_dialog] = useState();
    const [Dialog_Detail_Article_open, setDialog_Detail_Article_open] = React.useState(false);

    const Close_Dialog_Detail_Article_open = () => {

        setDialog_Detail_Article_open(false);
    };


    const [Add_Update_One_Order_Line_Data_api, setAdd_Update_One_Order_Line_Data_api] = useState();
    const [Add_Update_One_Order_Line_Data_message, setAdd_Update_One_Order_Line_Data_message] = useState();
    const [Add_Update_One_Order_Line_Data_result, setAdd_Update_One_Order_Line_Data_result] = useState();
    function Add_Update_One_Order_Line_Data() {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("order_line_formation", p_add_line_item_internal_url);
        form.append("order_line_qty", p_add_line_item_qty);
        form.append("order_line_prix_unitaire", p_add_line_item_price);
        form.append("order_line_id", selected_order_line_id);
        form.append("order_header_ref_interne", order_internal_ref);
        form.append("order_header_id", selected_id);
        form.append("order_line_status", p_add_line_item_status);
        form.append("order_line_type", p_add_line_item_type);
        form.append("order_line_comment", p_add_line_item_comment);

        //onsole.log("### form = ", form);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Add_Update_Partner_Order_Line/";


        axios.post(myurl, form).then(res => {
            //console.log(" In Add_Update_One_Order_Line_Data  res.data.status = " + res.data.status);
            //console.log(" In Add_Update_One_Order_Line_Data  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setAdd_Update_One_Order_Line_Data_api("true");
                setAdd_Update_One_Order_Line_Data_result(res.data.message);
                clean_article_detail_fields();

                Display_Detail_Order_data(selected_id);
                alert(" La mise à jour été correctement faite.");

                myRef_head.current.scrollIntoView({ behavior: "smooth" });

            }
            else {
                setAdd_Update_One_Order_Line_Data_api("false");
                setAdd_Update_One_Order_Line_Data_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {

            console.warn('UpdateStagiaireData : Not good man :( Add_Update_One_Order_Line_Data = ' + error);
            setAdd_Update_One_Order_Line_Data_api("false");
            alert(" Impossible d'ajouter / mettre à jour la ligne");

        })
    }



    const Update_Dialog_Detail_Article_open = () => {
        Add_Update_One_Order_Line_Data();
        setDialog_Detail_Article_open(false);
    };


    const [p_add_line_item, setp_add_line_item] = useState();
    const [p_add_line_item_internal_url, setp_add_line_item_internal_url] = useState();
    const [p_add_line_item_title, setp_add_line_item_title] = useState();
    const [p_add_line_item_qty, setp_add_line_item_qty] = useState();
    const [p_add_line_item_price, setp_add_line_item_price] = useState();
    const [p_add_line_item_comment, setp_add_line_item_comment] = useState();
    const [p_add_line_item_status, setp_add_line_item_status] = useState();
    const [p_add_line_item_type, setp_add_line_item_type] = useState();


    function clean_article_detail_fields() {
        setp_add_line_item();
        setp_add_line_item_internal_url();
        setp_add_line_item_title();
        setp_add_line_item_qty();
        setp_add_line_item_price();
        setp_add_line_item_comment();
        setp_add_line_item_status();
        setp_add_line_item_type();
    }


    function Ajouter_une_ligne_article() {
        setp_add_line_item("");
        setp_add_line_item_qty("");
        setp_add_line_item_price("");
        setp_add_line_item_comment("");
        setp_add_line_item_status(p_detail_header_statut);
        setp_add_line_item_type(p_detail_header_type);

        setDialog_Detail_Article_open(true);
    }

    const [Dialog_Detail_Commande_open, setDialog_Detail_Commande_open] = useState(false);


    function Dialog_cmd_handleClose() {

    }

    const Dialog_cmd_handleClose_buton = () => {
        setDialog_Detail_Commande_open(false);
    };




    const Close_Dialog_Detail_Order_open = () => {
        clean_order_detail_fields();
        setDialog_Detail_Commande_open(false);
    };


    const [Add_Dialog_Detail_Order_api, setAdd_Dialog_Detail_Order_api] = useState();
    const [Add_Dialog_Detail_Order_message, setAdd_Dialog_Detail_Order_message] = useState();
    const [Add_Dialog_Detail_Order_result, setAdd_Dialog_Detail_Order_result] = useState();
    function Add_Dialog_Detail_Order() {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("order_header_client_id", p_add_cmd_header_client_id);
        form.append("order_header_description", p_add_cmd_header_description);
        form.append("order_header_comment", p_add_cmd_header_comment);
        form.append("order_header_date_cmd", p_add_cmd_header_date_cmd);
        form.append("order_header_date_expiration", p_add_cmd_header_date_expiration_cmd);
        form.append("order_header_condition_paiement", p_add_cmd_header_condition_paiement);
        form.append("order_header_ref_client", p_add_cmd_header_ref_client);
        form.append("order_header_vendeur_id", p_add_cmd_header_vendeur_id);
        form.append("order_header_type", p_add_cmd_header_order_type);


        console.log("### form = ", form);
        var myurl = ""

        if (String(p_add_cmd_header_order_type) === "devis") {
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Add_Partner_Quotation/";
        } else if (String(p_add_cmd_header_order_type) === "commande") {
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Add_Partner_Order/";
        } else {
            alert(" Type de commande inconnu");
            return;
        }

        axios.post(myurl, form).then(res => {
            //console.log(" In Add_Update_One_Order_Line_Data  res.data.status = " + res.data.status);
            //console.log(" In Add_Update_One_Order_Line_Data  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setAdd_Dialog_Detail_Order_api("true");
                setAdd_Dialog_Detail_Order_result(res.data.message);
                clean_order_detail_fields();
                setDialog_Detail_Commande_open(false);
                Getall_Parter_Orders_No_Filter();

                if (String(p_add_cmd_header_order_type) === "devis") {
                    alert(" La devis à jour été correctement ajouté.");
                } else if (String(p_add_cmd_header_order_type) === "commande") {
                    alert(" La commande à jour été correctement ajoutée.");
                }

                myRef_head.current.scrollIntoView({ behavior: "smooth" });

            }
            else {
                setAdd_Dialog_Detail_Order_api("false");
                setAdd_Dialog_Detail_Order_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {

            console.warn('Add_Dialog_Detail_Order : Not good man :( Add_Dialog_Detail_Order = ' + error);
            setAdd_Dialog_Detail_Order_api("false");

            if (String(p_add_cmd_header_order_type) === "devis") {
                alert(" Impossible d'ajouter le devis");
            } else if (String(p_add_cmd_header_order_type) === "commande") {
                alert(" La commande d'ajouter la commande.");
            }

        })


    }

    const Dialog_Order_handleClose = () => {
        //alert(" Utiliser le bouton 'fermer' ");
        //setOpen(false);
    };


    const [p_add_cmd_header_client_id, setp_add_cmd_header_client_id] = useState("");
    const [p_add_cmd_header_description, setp_add_cmd_header_description] = useState("");
    const [p_add_cmd_header_comment, setp_add_cmd_header_comment] = useState("");
    const [p_add_cmd_header_vendeur_id, setp_add_cmd_header_vendeur_id] = useState("");
    const [p_add_cmd_header_date_cmd, setp_add_cmd_header_date_cmd] = useState(new Date().toLocaleDateString('fr-FR'));
    const [p_add_cmd_header_date_expiration_cmd, setp_add_cmd_header_date_expiration_cmd] = useState(date_today_90j.toLocaleDateString('fr-FR'));
    const [p_add_cmd_header_order_type, setp_add_cmd_header_order_type] = useState("");
    const [p_add_cmd_header_order_location_type, setp_add_cmd_header_order_location_type] = useState("");
    const [p_add_cmd_header_ref_client, setp_add_cmd_header_ref_client] = useState("");
    const [p_add_cmd_header_condition_paiement, setp_add_cmd_header_condition_paiement] = useState("");


    function clean_order_detail_fields() {
        setp_add_cmd_header_client_id();
        setp_add_cmd_header_description();
        setp_add_cmd_header_comment();
        setp_add_cmd_header_vendeur_id();
        setp_add_cmd_header_date_cmd(new Date().toLocaleDateString('fr-FR'));
        setp_add_cmd_header_date_expiration_cmd(date_today_90j.toLocaleDateString('fr-FR'));
        setp_add_cmd_header_order_type();
        setp_add_cmd_header_order_location_type();

        setp_add_cmd_header_ref_client();
        setp_add_cmd_header_condition_paiement();

    }

    return (

        <div className="partner_commande">

            <Dialog
                open={Dialog_1_open}
                onClose={Dialog_1_handleClose}

            >

                <DialogTitle>MySy Information</DialogTitle>
                <DialogContent>
                    <DialogContentText>
                        {Dialog_1_message}
                    </DialogContentText>

                </DialogContent>

                <DialogActions>
                    <Button onClick={Dialog_1_handleClose_buton}>OK</Button>

                </DialogActions>
            </Dialog>



            <Dialog
                open={Dialog_Detail_Article_open}
                onClose={Dialog_1_handleClose}
                className="partner_commande"
            >

                <DialogTitle>Détail ligne</DialogTitle>
                <DialogContent>
                    <DialogContentText>
                        Edition d'un ligne de commande / devis
                    </DialogContentText>



                    <TextField
                        autoFocus
                        margin="dense"
                        id="ref_article"
                        label="Article"
                        select
                        fullWidth
                        variant="standard"
                        value={p_add_line_item}
                        onChange={(e) => {
                            setp_add_line_item(e.target.value);
                            setp_add_line_item_internal_url(e.target.value);
                            const div1 = document.getElementById("mysy_item_class");
                            const mysy_item_class_title = div1.getAttribute('mysy_item_class_title');
                            setp_add_line_item_title(mysy_item_class_title);
                            //console.log(" Selected title = ", mysy_item_class_title);
                        }
                        }
                    >
                        {GetCurrentPartnerClass_result &&
                            GetCurrentPartnerClass_result.map((myclass) => (
                                <MenuItem key={JSON.parse(myclass).internal_url} value={JSON.parse(myclass).internal_url} style={{ "paddingLeft": "5px", "textAlign": "left", }}
                                    id="mysy_item_class"
                                    mysy_item_class_title={JSON.parse(myclass).title}>
                                    {JSON.parse(myclass).title}

                                </MenuItem>
                            ))}
                    </TextField>



                    <TextField
                        autoFocus
                        margin="dense"
                        id="ref_article_qty"
                        label="Quantité"
                        type="number"
                        fullWidth
                        variant="standard"
                        value={p_add_line_item_qty}
                        onChange={(e) => {
                            setp_add_line_item_qty(e.target.value);

                        }
                        }
                    />
                    <TextField
                        autoFocus
                        margin="dense"
                        id="ref_article_unit_price"
                        label="Prix Unitaie"
                        type="number"
                        fullWidth
                        variant="standard"
                        value={p_add_line_item_price}
                        onChange={(e) => {
                            setp_add_line_item_price(e.target.value);

                        }
                        }
                    />


                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}

                        name="ref_article_comment"
                        id="ref_article_comment"
                        autoFocus
                        fullWidth

                        value={p_add_line_item_comment}
                        onChange={(e) => {
                            setp_add_line_item_comment(e.target.value);

                        }
                        }
                        label="Commentaire"
                        variant="standard"

                    />


                </DialogContent>

                <DialogActions>

                    <div className="div_row">
                        <div className="div_row_gauche">
                            <Button onClick={Update_Dialog_Detail_Article_open} className="bton_enreg">Mettre à jour</Button>
                        </div>
                        <div className="div_row_droite" style={{ "textAlign": 'center' }}>
                            <Button onClick={Close_Dialog_Detail_Article_open} className="bton_annule" >Annuler</Button>
                        </div>

                    </div>

                </DialogActions>
            </Dialog>


            <Dialog
                open={Dialog_Detail_Commande_open}
                onClose={Dialog_Order_handleClose}
                className="partner_commande"
            >

                <DialogTitle>Nouvelle Commande</DialogTitle>
                <DialogContent>
                    <DialogContentText>
                        Ajout d'une commande / devis
                    </DialogContentText>



                    <TextField
                        autoFocus
                        margin="dense"
                        id="ref_client"
                        label="Client"
                        select
                        fullWidth
                        variant="standard"
                        value={p_add_cmd_header_client_id}
                        onChange={(e) => {
                            setp_add_cmd_header_client_id(e.target.value);
                            /*setp_add_line_item_internal_url(e.target.value);
                            const div1 = document.getElementById("mysy_item_class");
                            const mysy_item_class_title = div1.getAttribute('mysy_item_class_title');
                            setp_add_line_item_title(mysy_item_class_title);
                            //console.log(" Selected title = ", mysy_item_class_title); */
                        }
                        }
                    >
                        {Get_List_Partner_Clients_result &&
                            Get_List_Partner_Clients_result.map((myclient) => (
                                <MenuItem key={JSON.parse(myclient).nom} value={JSON.parse(myclient)._id}
                                    style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>
                                    {JSON.parse(myclient).nom}&nbsp;&nbsp;

                                </MenuItem>
                            ))}
                    </TextField>

                    {/*p_add_cmd_header_client_id && <div className="div_row">

                        <div className="div_row"> Adresse client
                        </div>

                        <div className="div_row"> Adresse Facturation
                        </div>

                            </div>*/}


                    <div style={{ "textAlign": "left" }}>Date cmd <br />

                        <DatePicker
                            name="date_order"
                            id="date_order"
                            selected={new Date(moment(p_add_cmd_header_date_cmd, "DD/MM/YYYY HH:mm:ss"))}
                            onChange={(date) => {
                                setp_add_cmd_header_date_cmd(format(date, 'dd/MM/yyyy'));

                            }
                            }
                            showTimeSelect={false}
                            //filterTime={filterPassedTime_start}
                            dateFormat="dd/MM/yyyy"
                            className="disabled_style enable_style"
                            locale='fr-FR'
                            fullWidth
                        />
                    </div>

                    <div style={{ "textAlign": "left" }}>Date expiration <br />

                        <DatePicker
                            name="date_order_exp"
                            id="date_order_exp"
                            label="expidate"
                            selected={new Date(moment(p_add_cmd_header_date_expiration_cmd, "DD/MM/YYYY HH:mm:ss"))}
                            onChange={(date) => {
                                setp_add_cmd_header_date_expiration_cmd(format(date, 'dd/MM/yyyy'));

                            }
                            }
                            showTimeSelect={false}
                            //filterTime={filterPassedTime_start}
                            dateFormat="dd/MM/yyyy"
                            className="disabled_style enable_style"
                            locale='fr-FR'
                            fullWidth
                        />
                    </div>



                    <TextField
                        autoFocus
                        margin="dense"
                        id="order_description"
                        label="Description"
                        type="text"
                        fullWidth
                        variant="standard"
                        value={p_add_cmd_header_description}
                        onChange={(e) => {
                            setp_add_cmd_header_description(e.target.value);

                        }
                        }
                    />

                    <TextField
                        autoFocus
                        margin="dense"
                        id="order_ref_client"
                        label="Ref. externe"
                        type="text"
                        fullWidth
                        variant="standard"
                        value={p_add_cmd_header_ref_client}
                        onChange={(e) => {
                            setp_add_cmd_header_ref_client(e.target.value);

                        }
                        }
                    />

                    <TextField
                        autoFocus
                        margin="dense"
                        id="ref_vendeur"
                        label="Vendeur"
                        select
                        fullWidth
                        variant="standard"
                        value={p_add_cmd_header_vendeur_id}
                        onChange={(e) => {
                            setp_add_cmd_header_vendeur_id(e.target.value);

                        }
                        }
                    >
                        {Getall_Training_Employee_No_Filter_result &&
                            Getall_Training_Employee_No_Filter_result.map((myclient) => (
                                <MenuItem key={JSON.parse(myclient)._id} value={JSON.parse(myclient)._id}
                                    style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>
                                    {JSON.parse(myclient).nom}&nbsp; {JSON.parse(myclient).prenom}

                                </MenuItem>
                            ))}
                    </TextField>


                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        name="order_paiement_condition"
                        id="order_paiement_condition"
                        autoFocus
                        fullWidth
                        value={p_add_cmd_header_condition_paiement}
                        onChange={(e) => {
                            setp_add_cmd_header_condition_paiement(e.target.value);

                        }
                        }
                        label="Conditions Paiement"
                        variant="standard"

                    />

                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        name="order_type"
                        id="order_type"
                        autoFocus
                        fullWidth
                        value={p_add_cmd_header_order_type}
                        onChange={(e) => {
                            setp_add_cmd_header_order_type(e.target.value);

                        }
                        }
                        label="Type"
                        variant="standard"
                        select

                    >
                        <MenuItem value="devis" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Devis &nbsp;</MenuItem>
                        <MenuItem value="commande" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Commande  &nbsp;</MenuItem>

                    </TextField>


                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        name="order_header_location_type"
                        id="order_header_location_type"
                        autoFocus
                        fullWidth
                        value={p_add_cmd_header_order_location_type}
                        onChange={(e) => {
                            setp_add_cmd_header_order_location_type(e.target.value);

                        }
                        }
                        label="Emplacement"
                        variant="standard"
                        select

                    >
                        <MenuItem value="inter" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Inter &nbsp;</MenuItem>
                        <MenuItem value="intra" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Intra  &nbsp;</MenuItem>
                        <MenuItem value="" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Autre  &nbsp;</MenuItem>

                    </TextField>


                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        name="order_commentaire"
                        id="order_commentaire"
                        autoFocus
                        fullWidth
                        value={p_add_cmd_header_comment}
                        onChange={(e) => {
                            setp_add_cmd_header_comment(e.target.value);

                        }
                        }
                        label="Commentaire"
                        variant="standard"

                    />
                    <div className="div_row"> &nbsp;</div>

                </DialogContent>

                <DialogActions>

                    <div className="div_row">
                        <div className="div_row_gauche">
                            <Button onClick={Add_Dialog_Detail_Order} className="bton_enreg">Ajouter</Button>
                        </div>
                        <div className="div_row_droite" style={{ "textAlign": 'center' }}>
                            <Button onClick={Close_Dialog_Detail_Order_open} className="bton_annule" >Annuler</Button>
                        </div>

                    </div>

                </DialogActions>
            </Dialog>


            <h3> Vos Commandes et Devis </h3>
            <div className="div_row">
                <div className="titre1">  Utilisez les filtres !</div>
                <div className="div_row" style={{ "marginBottom": "5px" }}>
                    <div className="div_row_gauche texte_area_filter" >
                        <TextField
                            name="filtre1"
                            label="Choisir un champ"
                            select
                            sx={{ m: 1, width: '100%' }}
                            value={p_filtre1}
                            onChange={(e) => {
                                setp_filtre1(e.target.value);

                            }}
                        >
                            <MenuItem value="email" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Email &nbsp;</MenuItem>
                            <MenuItem value="nom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Nom  &nbsp;</MenuItem>
                            <MenuItem value="formation" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Formation (code externe) &nbsp;</MenuItem>
                            <MenuItem value="session" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Session (code session) &nbsp;</MenuItem>


                        </TextField>
                    </div>



                    <div className="div_row_droite texte_area_filter_value" >
                        {p_filtre1 &&
                            <TextField
                                sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                required
                                name="filtre1_value"
                                id="filtre1_value"

                                InputLabelProps={{
                                    shrink: true,
                                }}
                                disabled={false}
                                className="disabled_style"
                                value={p_filtre1_value}
                                onChange={(e) => { setp_filtre1_value(e.target.value); }}
                                InputProps={{
                                    endAdornment: (
                                        <InputAdornment position="end">
                                            <AiFillCloseCircle
                                                style={{ 'cursor': "pointer", "color": "orangered" }}
                                                onClick={(e) => {
                                                    setp_filtre1_value("");
                                                }} />
                                        </InputAdornment>
                                    ),
                                }}

                            />

                        }
                    </div>
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip id="my-tooltip01" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip01" data-tooltip-content="Ajouter une nouvelle ligne de filtre">
                            &nbsp; <MdAddCircleOutline onClick={(e) => {
                                setp_filtre2("1");
                                setp_filtre2_value("");
                            }} />
                        </a>
                    </div>}
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip id="my-tooltip02" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip02" data-tooltip-content="Supprimer cette ligne de filtre">
                            &nbsp; <MdRemoveCircleOutline onClick={(e) => {
                                setp_filtre1();
                                setp_filtre1_value();
                            }}
                            />
                        </a>
                    </div>}


                </div>

                {p_filtre2 &&
                    <div className="div_row" style={{ "marginBottom": "5px" }}>
                        <div className="div_row_gauche texte_area_filter">
                            <TextField
                                name="filtre2"
                                label="Choisir un champ"
                                select
                                sx={{ m: 1, width: '100%' }}

                                value={p_filtre2}
                                onChange={(e) => {
                                    setp_filtre2(e.target.value);

                                }}
                            >
                                <MenuItem value="email" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Email &nbsp;</MenuItem>
                                <MenuItem value="nom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Nom  &nbsp;</MenuItem>
                                <MenuItem value="formation" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Formation (code externe) &nbsp;</MenuItem>
                                <MenuItem value="session" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Session (code session) &nbsp;</MenuItem>


                            </TextField>
                        </div>
                        <div className="div_row_droite texte_area_filter_value" style={{ "marginTop": "0.5rem" }}>
                            {String(p_filtre2).length > 2 &&
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="filtre2_value"
                                    id="filtre2_value"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_filtre2_value}
                                    onChange={(e) => setp_filtre2_value(e.target.value)}
                                    InputProps={{
                                        endAdornment: (
                                            <InputAdornment position="end">
                                                <AiFillCloseCircle
                                                    style={{ 'cursor': "pointer", "color": "orangered" }}
                                                    onClick={(e) => {
                                                        setp_filtre2_value("");
                                                    }} />
                                            </InputAdornment>
                                        ),
                                    }}

                                />}
                        </div>

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add' >
                            <Tooltip id="my-tooltip03" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip03" data-tooltip-content="Ajouter une nouvelle ligne de filtre">
                                &nbsp; <MdAddCircleOutline
                                    onClick={(e) => {
                                        setp_filtre3("1");
                                        setp_filtre3_value("");
                                    }}
                                />
                            </a>
                        </div>}

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add'>
                            <Tooltip id="my-tooltip04" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip04" data-tooltip-content="Supprimer cette ligne de filtre">
                                &nbsp; <MdRemoveCircleOutline
                                    onClick={(e) => {
                                        setp_filtre2();
                                        setp_filtre2_value();
                                    }}
                                />
                            </a>
                        </div>}

                    </div>
                }


                {p_filtre3 &&
                    <div className="div_row" style={{ "marginBottom": "5px" }}>
                        <div className="div_row_gauche texte_area_filter">
                            <TextField
                                name="filtre3"
                                label="Choisir un champ"
                                select
                                sx={{ m: 1, width: '100%' }}

                                value={p_filtre3}
                                onChange={(e) => {
                                    setp_filtre3(e.target.value)
                                }}
                            >
                                <MenuItem value="email" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Email &nbsp;</MenuItem>
                                <MenuItem value="nom" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Nom  &nbsp;</MenuItem>
                                <MenuItem value="formation" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Formation (code externe) &nbsp;</MenuItem>
                                <MenuItem value="session" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Lié a la Session (code session) &nbsp;</MenuItem>


                            </TextField>
                        </div>
                        <div className="div_row_droite texte_area_filter_value" style={{ "marginTop": "0.5rem" }}>
                            {String(p_filtre3).length > 2 &&
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="filtre3_value"
                                    id="filtre3_value"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_filtre3_value}
                                    onChange={(e) => setp_filtre3_value(e.target.value)}
                                    InputProps={{
                                        endAdornment: (
                                            <InputAdornment position="end">
                                                <AiFillCloseCircle
                                                    style={{ 'cursor': "pointer", "color": "orangered" }}
                                                    onClick={(e) => {
                                                        setp_filtre3_value("");
                                                    }} />
                                            </InputAdornment>
                                        ),
                                    }}

                                />}
                        </div>

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add' >
                            <Tooltip id="my-tooltip03" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip03" data-tooltip-content="Ajouter une nouvelle ligne de filtre">
                                &nbsp; <MdAddCircleOutline
                                    onClick={(e) => {
                                        setp_filtre4("1");
                                        setp_filtre4_value("");
                                    }}
                                />
                            </a>
                        </div>}

                        {String(p_filtre3).length > 2 && <div className='filter_bton_add'>
                            <Tooltip id="my-tooltip05" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip05" data-tooltip-content="Supprimer cette ligne de filtre">
                                &nbsp; <MdRemoveCircleOutline onClick={(e) => {
                                    setp_filtre3();
                                    setp_filtre3_value();
                                }} />
                            </a>
                        </div>}
                    </div>
                }


                <div className="div_row" ref={myRef_head} style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                    <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>
                        <Button variant="contained" className="bton_enreg" onClick={"Getall_Training_Employee"}>Rechercher
                        </Button>
                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                        <Button variant="contained" className="bton_annule" onClick={"clean_all_filters"}>Annuler
                        </Button>

                    </div>

                </div>

                <br />
            </div>

            <div className="div_row">
                <div className="session_data">
                    <div style={{ "border": "None" }}>

                        <div style={{ height: 550, width: '100%', paddingRight: '1px' }}>
                            &nbsp;
                            <Box
                                sx={{
                                    height: 500,
                                    width: '100%',
                                    paddingRight: '1px',

                                    // Gestion des cellule a distance ou presentiel
                                    '& .cell--distantiel': {
                                        backgroundColor: '#AFE1AF',
                                        color: 'black',
                                    },

                                    '& .cell--presentiel': {
                                        backgroundColor: '#AFE1AF',
                                        color: 'black',
                                    },


                                    // gestion couleur des lignes avec le statut d'inscription
                                    '& .line--statut--annule': {
                                        backgroundColor: '#D8D8D8',
                                        color: 'white',
                                    },

                                    '& .line--statut--inscrit': {
                                        backgroundColor: '#CEF6D8',
                                        color: 'black',
                                    },
                                    '& .line--statut--preinscrit': {
                                        backgroundColor: '#F7F2E0',
                                        color: 'black',
                                    },

                                    /*"& .MuiDataGrid-virtualScrollerRenderZone": {
                                        "& .MuiDataGrid-row": {
                                            "&:nth-child(2n)": { backgroundColor: "rgba(235, 235, 235, .7)" }
                                        }
                                    },*/
                                    "& .MuiDataGrid-columnHeaders": {
                                        backgroundColor: "#c8cfd5",
                                        color: "black",
                                        fontSize: 14
                                    },

                                }}
                            >
                                <DataGrid
                                    checkboxSelection
                                    onSelectionModelChange={(newSelectionModel) => {
                                        setSelectionModel(newSelectionModel);
                                        if (newSelectionModel.length === 1)
                                            handleClick_edit_order_From_Line(newSelectionModel);
                                        if (newSelectionModel.length !== 1) {
                                            setsubmenu();
                                            setdisplay_detail_order();
                                            setadd_One_Order();
                                        }
                                    }}
                                    selectionModel={selectionModel}

                                    localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                    rows={rowss.map((item, index) => (
                                        {
                                            id: index,
                                            _id: JSON.parse(item)._id,
                                            order_header_ref_interne: JSON.parse(item).order_header_ref_interne,
                                            order_header_type: JSON.parse(item).order_header_type,
                                            order_header_status: JSON.parse(item).order_header_status,
                                            order_header_client_id: JSON.parse(item).order_header_client_id,
                                            order_header_client_nom: JSON.parse(item).order_header_client_nom,
                                            order_header_vendeur_id: JSON.parse(item).order_header_vendeur_id,
                                            order_header_vendeur_nom_prenom: JSON.parse(item).order_header_vendeur_nom_prenom,
                                            order_header_date_cmd: JSON.parse(item).order_header_date_cmd,
                                            order_header_date_expiration: JSON.parse(item).order_header_date_expiration,

                                        }
                                    ))}

                                    columns={columns}
                                    pageSize={10}
                                    className="datagridclass"

                                    rowsPerPageOptions={[10]}
                                    //disableSelectionOnClick
                                    components={{
                                        Toolbar: GridToolbar,
                                    }}
                                    //sx={datagridSx}
                                    getCellClassName={(params) => {
                                        //field === 'distantiel'
                                        if (params.field === 'distantiel' && String(params.value) === "1") {
                                            return 'cell--distantiel';
                                        }
                                        if (params.field === "presentiel" && String(params.value) == "1") {
                                            return 'cell--presentiel';
                                        }


                                        //field === "statut"
                                        if (params.field === "status" && String(params.value) == "0") {
                                            return 'cell--statut--preinscrit';
                                        }

                                        if (params.field === "status" && String(params.value) == "1") {
                                            return 'cell--statut--inscrit';
                                        }

                                        if (params.field === "status" && String(params.value) == "-1") {
                                            return 'cell--statut--annule';
                                        }

                                    }}
                                    getRowClassName={(params) => {

                                        if (String(params.row.status) === "-1") {
                                            return 'line--statut--annule';
                                        }
                                        if (String(params.row.status) === "0") {
                                            return 'line--statut--preinscrit';
                                        }
                                        if (String(params.row.status) === "1") {
                                            return 'line--statut--inscrit';
                                        }
                                    }}


                                />
                            </Box>
                            <br />

                        </div>

                    </div>

                </div>

                <div className="div_row" style={{ "border": "None" }}>

                    <div className="div_row_gauche div_row_gauche_etendu" style={{ "textAlign": "left", "paddingLeft": "5px" }}>

                        <Button variant="outlined" onClick={submenu_import_order} className="detail_class_submenu bton_import_excel"
                            id='menu_import_participant' name='menu_import_participant'>Importer des commande / devis Excel &nbsp;
                            <img src={excel_icone} alt="ajout csv" className="icon_excel" />
                        </Button>


                        <Button variant="outlined" onClick={submenu_add_one_order}
                            className="detail_class_submenu bton_add_session"
                            id='menu_import_participant' name='menu_import_participant'>Ajout 1 Commande &nbsp;
                            <img src={add_plus} alt="ajout session" className="icon_plus" />
                        </Button>

                        <Button variant="outlined" onClick={submenu_add_one_order}
                            className="detail_class_submenu bton_add_session"
                            id='menu_import_participant' name='menu_import_participant'>Ajout 1 Devis &nbsp;
                            <img src={add_plus} alt="ajout session" className="icon_plus" />
                        </Button>

                        <br />
                        {session_file_name && <nav><i>{session_file_name}</i></nav>}
                        {String(liste_sessions_file_change_api) === String("true") && <nav className="okUpdateData"> Les commandes/devis ont été correctement importés</nav>}
                        {String(liste_sessions_file_change_api) === String("false") && <nav className="koUpdateData"> {liste_sessions_file_change_message} </nav>}

                        <input type="file"
                            accept=".csv"
                            ref={hiddenFileInput_session}
                            style={{ display: 'none' }}
                            name="liste_sessions_file"
                            onChange={liste_sessions_file_change}
                        />

                        <a href='/sample/template_import_employes.csv' download>Télécharger un fichier modèle</a>
                    </div>
                </div>
                <div className="div_row"> &nbsp;</div>
                <div className="div_row">
                    <Button variant="outlined" ref={myRef} onClick={"submenu_detail_employe"} className="detail_class_submenu" id='detail_employe' name='detail_employe'>Détail employé</Button>
                    <Button variant="outlined" onClick={"submenu_droit_acces"} className="detail_class_submenu" id='droit_acces' name='droit_acces'>Droits d'acces  </Button>
                    <Button variant="outlined" onClick={"submenu_affectation"} className="detail_class_submenu" id='affectation' name='affectation'>Affectation  </Button>


                </div>

                {String(submenu) === "detail_order" && String(add_One_Order) !== "1" && <div className="div_row">
                    <h3> Affichage detaillé d'une commande / devis </h3>
                    <div>
                        <div className="session_data" >

                            <div> Entete de commande </div>
                            <div className="session_caract"> Type<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_type"
                                    id="detail_header_type"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_type}
                                    onChange={(e) => {
                                        setp_detail_header_type(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>

                            {String(order_data_edit_mode) !== "1" && <div className="session_caract"> Statut<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_status"
                                    id="detail_header_status"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_statut_label}
                                    onChange={(e) => {
                                        setp_detail_header_statut(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>}
                            {String(order_data_edit_mode) === "1" && String(p_detail_header_type) === "commande" && <div className="session_caract"> Statut<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_status"
                                    id="detail_header_status"
                                    select
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_statut}
                                    onChange={(e) => {
                                        setp_detail_header_statut(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                >
                                    <MenuItem value="0" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Brouillon &nbsp;&nbsp;</MenuItem>
                                    <MenuItem value="1" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >En cours &nbsp;</MenuItem>
                                    <MenuItem value="2" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Traité &nbsp;</MenuItem>
                                    <MenuItem value="3" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Facturé &nbsp;</MenuItem>
                                    <MenuItem value="-1" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Annulé &nbsp;</MenuItem>
                                </TextField>

                            </div>}
                            {String(order_data_edit_mode) === "1" && String(p_detail_header_type) === "devis" && <div className="session_caract"> Statut<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_status"
                                    id="detail_header_status"
                                    select
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_statut}
                                    onChange={(e) => {
                                        setp_detail_header_statut(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                >
                                    <MenuItem value="0" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }}>Brouillon &nbsp;&nbsp;</MenuItem>
                                    <MenuItem value="1" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >En cours &nbsp;</MenuItem>
                                    <MenuItem value="2" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Fermé &nbsp;</MenuItem>
                                    <MenuItem value="-1" style={{ "paddingLeft": "5px", "textAlign": "left", "width": "100%" }} >Annulé &nbsp;</MenuItem>
                                </TextField>

                            </div>}

                            <div className="session_caract"> Ref. Interne<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_ref_interne"
                                    id="detail_header_ref_interne"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_ref_interne}
                                    onChange={(e) => {
                                        setp_detail_header_ref_interne(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>

                            {String(order_data_edit_mode) !== "1" && <div className="session_caract"> Date Cmd<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_date_cmd"
                                    id="detail_header_date_cmd"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_date_cmd}
                                    onChange={(e) => {
                                        setp_detail_header_date_cmd(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>}

                            {String(order_data_edit_mode) === "1" && <div className="session_caract"> Date Cmd<br />
                                <DatePicker
                                    name="detail_header_date_cmd"
                                    id="detail_header_date_cmd"
                                    selected={new Date(moment(p_detail_header_date_cmd_val, "DD/MM/YYYY HH:mm:ss"))}
                                    onChange={(date) => {
                                        setp_detail_header_date_cmd_val(format(date, 'dd/MM/yyyy'));
                                        setOrder_data_changed("1");
                                    }
                                    }
                                    showTimeSelect={false}
                                    //filterTime={filterPassedTime_start}
                                    dateFormat="dd/MM/yyyy"
                                    className="disabled_style enable_style"
                                    locale='fr-FR'
                                />
                            </div>}


                            {String(order_data_edit_mode) !== "1" && <div className="session_caract"> Date expiration<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_date_expiration"
                                    id="detail_header_date_expiration"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_date_expiration}
                                    onChange={(e) => {
                                        setp_detail_header_date_expiration(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>}

                            {String(order_data_edit_mode) === "1" && <div className="session_caract"> Date expiration<br />
                                <DatePicker
                                    name="detail_header_date_expiration"
                                    id="detail_header_date_expiration"
                                    selected={new Date(moment(p_detail_header_date_expiration_val, "DD/MM/YYYY HH:mm:ss"))}
                                    onChange={(date) => {
                                        setp_detail_header_date_expiration_val(format(date, 'dd/MM/yyyy'));
                                        setOrder_data_changed("1");
                                    }
                                    }
                                    showTimeSelect={false}
                                    //filterTime={filterPassedTime_start}
                                    dateFormat="dd/MM/yyyy"
                                    className="disabled_style enable_style"
                                    locale='fr-FR'
                                />
                            </div>}



                            {String(order_data_edit_mode) !== "1" && <div className="session_caract"> Nom Client<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_nom_client"
                                    id="detail_nom_client"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_client_nom}
                                    onChange={(e) => {
                                        setp_detail_header_client_nom(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>}

                            {String(order_data_edit_mode) === "1" && <div className="session_caract"> Nom Client<br />

                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_nom_client"
                                    id="detail_nom_client"
                                    select
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_client_nom_id}
                                    onChange={(e) => {
                                        setp_detail_header_client_nom_id(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                >
                                    {Get_List_Partner_Clients_result &&
                                        Get_List_Partner_Clients_result.map((myclient) => (
                                            <MenuItem key={JSON.parse(myclient)._id} value={JSON.parse(myclient)._id}
                                                style={{ "paddingLeft": "5px", "textAlign": "left", }}>
                                                {JSON.parse(myclient).nom}&nbsp;&nbsp;

                                            </MenuItem>
                                        ))}

                                </TextField>
                            </div>}

                            <div className="session_caract"> Description<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_description"
                                    id="detail_header_description"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_description}
                                    onChange={(e) => {
                                        setp_detail_header_description(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>

                            <div className="session_caract"> Commentaire<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_comment"
                                    id="detail_header_comment"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_comment}
                                    onChange={(e) => {
                                        setp_detail_header_comment(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>

                            {String(order_data_edit_mode) !== "1" && <div className="session_caract"> Vendeur<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_vendeur_nom_prenom"
                                    id="detail_header_vendeur_nom_prenom"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_vendeur_nom}
                                    onChange={(e) => {
                                        setp_detail_header_vendeur_nom(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                />
                            </div>}

                            {String(order_data_edit_mode) === "1" && <div className="session_caract"> Vendeur<br />
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="detail_header_vendeur_nom_prenom"
                                    id="detail_header_vendeur_nom_prenom"
                                    select
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_header_vendeur_nom_id}
                                    onChange={(e) => {
                                        setp_detail_header_vendeur_nom_id(e.target.value);
                                        setOrder_data_changed("1");
                                    }
                                    }

                                >
                                    {Getall_Training_Employee_No_Filter_result &&
                                        Getall_Training_Employee_No_Filter_result.map((myclient) => (
                                            <MenuItem key={JSON.parse(myclient)._id} value={JSON.parse(myclient)._id}
                                                style={{ "paddingLeft": "5px", "textAlign": "left", }}>
                                                {JSON.parse(myclient).nom}&nbsp; {JSON.parse(myclient).prenom}

                                            </MenuItem>
                                        ))}

                                </TextField>
                            </div>}

                            <div>
                                <div className="div_row" style={{ "border": "None" }}>
                                    &nbsp;
                                </div>
                                {String(Order_data_changed) === "1" && String(order_data_edit_mode) === "1" && <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>
                                    /!\ Pensez à enregistrer les modifications
                                </div>}
                                <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                                    {String(Order_data_changed) === "1" && String(order_data_edit_mode) === "1" && <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>

                                        <Button variant="contained" className="bton_enreg" onClick={Update_One_Order_Data}>Enregistrer les modifications
                                        </Button>

                                    </div>}

                                    {String(order_data_edit_mode) === "1" && <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }} >
                                        <Button variant="contained" className="bton_annule" onClick={Annule_Order_DetailFields}>Annuler
                                        </Button>
                                    </div>}
                                </div>


                                {String(order_data_edit_mode) !== "1" && <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>

                                    <Button variant="contained" className="bton_edit" onClick={Enable_Order_Header_DetailFields}>Editer
                                    </Button>

                                </div>}
                                <div className="div_row" style={{ "border": "None" }}>
                                    &nbsp;
                                </div>
                            </div>
                        </div>

                        <div className="session_data" >
                            <div> Lignes de commande </div>
                            <div style={{ "border": "None" }}>
                                <nav onClick={Ajouter_une_ligne_article} style={{ "cursor": 'pointer' }}> Ajouter une ligne </nav>
                                <div style={{ height: 550, width: '100%', paddingRight: '1px' }}>
                                    &nbsp;
                                    <Box
                                        sx={{
                                            height: 500,
                                            width: '100%',
                                            paddingRight: '1px',

                                            // Gestion des cellule a distance ou presentiel
                                            '& .cell--distantiel': {
                                                backgroundColor: '#AFE1AF',
                                                color: 'black',
                                            },

                                            '& .cell--presentiel': {
                                                backgroundColor: '#AFE1AF',
                                                color: 'black',
                                            },


                                            // gestion couleur des lignes avec le statut d'inscription
                                            '& .line--statut--annule': {
                                                backgroundColor: '#D8D8D8',
                                                color: 'white',
                                            },

                                            '& .line--statut--inscrit': {
                                                backgroundColor: '#CEF6D8',
                                                color: 'black',
                                            },
                                            '& .line--statut--preinscrit': {
                                                backgroundColor: '#F7F2E0',
                                                color: 'black',
                                            },

                                            /*"& .MuiDataGrid-virtualScrollerRenderZone": {
                                                "& .MuiDataGrid-row": {
                                                    "&:nth-child(2n)": { backgroundColor: "rgba(235, 235, 235, .7)" }
                                                }
                                            },*/
                                            "& .MuiDataGrid-columnHeaders": {
                                                backgroundColor: "#c8cfd5",
                                                color: "black",
                                                fontSize: 14
                                            },

                                        }}
                                    >
                                        <DataGrid
                                            checkboxSelection
                                            onSelectionModelChange={(newSelectionModel) => {
                                                setselectionModel_order_lines(newSelectionModel);
                                                /*if (newSelectionModel.length === 1)
                                                    handleClick_edit_order_From_Line(newSelectionModel);
                                                if (newSelectionModel.length !== 1) {
                                                    setsubmenu();
                                                    setdisplay_detail_order();
                                                    setadd_One_Order();
                                                }*/
                                            }}
                                            selectionModel={selectionModel_order_lines}

                                            localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                            rows={rows_order_lines.map((item, index) => (
                                                {
                                                    id: index,
                                                    _id: JSON.parse(item)._id,
                                                    order_line_formation: JSON.parse(item).order_line_formation,
                                                    order_line_qty: JSON.parse(item).order_line_qty,
                                                    order_line_status: JSON.parse(item).order_line_status,
                                                    order_line_prix_unitaire: JSON.parse(item).order_line_prix_unitaire,
                                                    order_header_id: JSON.parse(item).order_header_id,
                                                    order_header_ref_interne: JSON.parse(item).order_header_ref_interne,
                                                    order_line_type: JSON.parse(item).order_line_type,
                                                    order_line_formation_title: JSON.parse(item).title,
                                                    order_line_formation_duration: JSON.parse(item).duration_concat,
                                                    order_line_comment: JSON.parse(item).order_line_comment,

                                                }
                                            ))}

                                            columns={columns_order_lines}
                                            pageSize={10}
                                            className="datagridclass"

                                            rowsPerPageOptions={[10]}
                                            //disableSelectionOnClick
                                            components={{
                                                Toolbar: GridToolbar,
                                            }}


                                        />
                                    </Box>
                                    <br />

                                </div>

                            </div>
                        </div>
                        <div>
                            <div className="div_row" style={{ "border": "None" }}>
                                &nbsp;
                            </div>
                            {String(Order_data_changed) === "1" && String(order_data_edit_mode) === "1" && <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>
                                /!\ Pensez à enregistrer les modifications
                            </div>}
                            <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                                {String(Order_data_changed) === "1" && String(order_data_edit_mode) === "1" && <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>

                                    <Button variant="contained" className="bton_enreg" onClick={Update_One_Order_Data}>Enregistrer les modifications
                                    </Button>

                                </div>}

                                {String(order_data_edit_mode) === "1" && <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }} >
                                    <Button variant="contained" className="bton_annule" onClick={Annule_Order_DetailFields}>Annuler
                                    </Button>
                                </div>}
                            </div>


                            {String(order_data_edit_mode) !== "1" && <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>

                                <Button variant="contained" className="bton_edit" onClick={Enable_Order_Header_DetailFields}>Editer
                                </Button>

                            </div>}
                            <div className="div_row" style={{ "border": "None" }}>
                                &nbsp;
                            </div>
                        </div>

                    </div>
                </div>}
            </div>


        </div>
    )
}


export default Partner_Commande;